#
# es1.s
#
# Settore di avviamento per floppy, stampa una stringa a schermo
#  e blocca la macchina in un ciclo infinito
#

.code16		# Necessario per eseguire il codice in modo reale

.set SEG_BOOT, 0x07c0
.set INIT_STACK, 0x400

	.text

	movw $SEG_BOOT, %ax	# caricamento di valori noti nei registri 
	movw %ax, %ds		#  selettore
	movw %ax, %es

	cli			# interruzioni disabilitate nel cambiamento
				#  di pila
	movw %ax, %ss
	movw $INIT_STACK, %sp	# pila iniziale a 0x07c0:0400, cioe'
				#  512 byte dopo la fine del settore
				#  di avviamento in memoria

	sti

	movw $mess, %si		# indirizzo del primo carattere del messaggio
				#  in si

				# impostazione parametri int 0x10:
	movb $0x0e, %ah		# servizio stampa carattere
	movb $0, %bh		# numero di pagina

nuovo_car:
	lodsb			# carica il carattere in al
	cmpb $0, %al		# verifica se e' l' ultimo
	je fine
	int $0x10		# lo stampa
	jmp nuovo_car

fine:	jmp fine		# ciclo infinito

mess:	.asciz "Hello World"

	.org 510
sign:	.byte	0x55		# signature per un settore di avviamento valido
	.byte	0xaa

